<!--
~ Copyright 2009 WSO2, Inc. (http://wso2.com)
~
~ Licensed under the Apache License, Version 2.0 (the "License");
~ you may not use this file except in compliance with the License.
~ You may obtain a copy of the License at
~
~ http://www.apache.org/licenses/LICENSE-2.0
~
~ Unless required by applicable law or agreed to in writing, software
~ distributed under the License is distributed on an "AS IS" BASIS,
~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
~ See the License for the specific language governing permissions and
~ limitations under the License.
-->

<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.bam.mgt.ui.client.BAMListAdminServiceClient" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.bam.mgt.ui.stub.bamconfig.types.carbon.MonitoredServerDTO" %>


<%@ page import="java.text.DecimalFormat" %>
<%@ page import="java.text.NumberFormat" %>
<%@ page import="org.wso2.carbon.bam.mgt.ui.client.BAMStatQueryDSClient" %>
<%@ page import="org.wso2.carbon.bam.mgt.ui.stat.Endpoint" %>
<%@ page import="org.wso2.carbon.bam.mgt.ui.stat.ProxyService" %>
<%@ page import="org.wso2.carbon.bam.mgt.ui.stat.Sequence" %>
<%@ page import="org.wso2.carbon.bam.mgt.ui.report.beans.MediationDataBean" %>
<%@ page import="java.util.List" %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="org.wso2.carbon.bam.mgt.ui.report.MediationDataReportDataManager" %>
<%@ page import="org.wso2.carbon.reporting.api.ReportingException" %>


<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar"
           prefix="carbon" %>

<fmt:bundle basename="org.wso2.carbon.bam.mgt.ui.i18n.Resources">
<div id="noDataError" style="display:none;"><fmt:message key="no.mediation.data"/></div>
<script type="text/javascript">
    var hasDataAnyWhere = false;
</script>
<ul class="root-list">
<%
    String serverURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    ConfigurationContext configContext = (ConfigurationContext) config.getServletContext()
            .getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    BAMListAdminServiceClient listAdminServiceClient = new BAMListAdminServiceClient(cookie,
            serverURL, configContext, request.getLocale());
    BAMStatQueryDSClient statQueryDSClient = new BAMStatQueryDSClient(cookie, serverURL,
            configContext, request.getLocale());

    MonitoredServerDTO[] serverList = listAdminServiceClient.getServerList();
    boolean hasData = false;
    //before everything we need to calculate the highest bar width that the bar can go
    Float maxBarWidhA = new Float("0");
    Float maxBarWidhB = new Float("0");
    if (serverList != null) {
        for (MonitoredServerDTO server : serverList) {
            Endpoint[] endpointsList = statQueryDSClient.getEndpoints(server.getServerId());
            if (endpointsList != null && endpointsList.length > 0) {
                for (Endpoint endpoint : endpointsList) {
                    if (endpoint != null) {
                        Float tmpValue = new Float(statQueryDSClient
                                .getLatestInAverageProcessingTimeForEndpoint(server.getServerId(), endpoint.getEndpoint()));
                        if (maxBarWidhA < tmpValue) {
                            maxBarWidhA = tmpValue;
                        }
                        tmpValue = new Float(statQueryDSClient
                                .getLatestInMaximumProcessingTimeForEndpoint(server.getServerId(),
                                endpoint.getEndpoint()));
                        if (maxBarWidhA < tmpValue) {
                            maxBarWidhA = tmpValue;
                        }
                        tmpValue = new Float(statQueryDSClient
                                .getLatestInMinimumProcessingTimeForEndpoint(server.getServerId(),
                                endpoint.getEndpoint()));
                        if (maxBarWidhA < tmpValue) {
                            maxBarWidhA = tmpValue;
                        }
                        //bar witdh B part

                        tmpValue = new Float(statQueryDSClient.getLatestInCumulativeCountForEndpoint(
                                server.getServerId(), endpoint.getEndpoint()));
                        if (maxBarWidhB < tmpValue) {
                            maxBarWidhB = tmpValue;
                        }
                        tmpValue = new Float(statQueryDSClient.getLatestInFaultCountForEndpoint(
                                server.getServerId(), endpoint.getEndpoint()));
                        if (maxBarWidhB < tmpValue) {
                            maxBarWidhB = tmpValue;
                        }
                    }
                }
            }
            ProxyService[] proxyServicesList = statQueryDSClient.getProxyServices(server
                    .getServerId());

            if (proxyServicesList != null && proxyServicesList.length > 0) {
                for (ProxyService proxyService : proxyServicesList) {
                    if (proxyService != null) {
                        Float tmpInt = new Float(statQueryDSClient
                                .getLatestInAverageProcessingTimeForProxy(server.getServerId(),
                                proxyService.getProxyService()));
                        if (maxBarWidhA < tmpInt) {
                            maxBarWidhA = tmpInt;
                        }
                        tmpInt = new Float(statQueryDSClient
                                .getLatestInMaximumProcessingTimeForProxy(server.getServerId(),
                                proxyService.getProxyService()));
                        if (maxBarWidhA < tmpInt) {
                            maxBarWidhA = tmpInt;
                        }
                        tmpInt = new Float(statQueryDSClient
                                .getLatestInMinimumProcessingTimeForProxy(server.getServerId(),
                                proxyService.getProxyService()));
                        if (maxBarWidhA < tmpInt) {
                            maxBarWidhA = tmpInt;
                        }

                        //bar witdh B part

                        tmpInt = new Float(statQueryDSClient.getLatestInCumulativeCountForProxy(
                                server.getServerId(), proxyService.getProxyService()));
                        if (maxBarWidhB < tmpInt) {
                            maxBarWidhB = tmpInt;
                        }
                        tmpInt = new Float(statQueryDSClient.getLatestInFaultCountForProxy(server
                                .getServerId(), proxyService.getProxyService()));
                        if (maxBarWidhB < tmpInt) {
                            maxBarWidhB = tmpInt;
                        }
                    }
                }
            }

            Sequence[] sequenceList = statQueryDSClient.getSequences(server.getServerId());

            if (sequenceList != null && sequenceList.length > 0) {
                for (Sequence sequence : sequenceList) {
                    if (sequence != null) {
                        Float tmpInt = new Float(statQueryDSClient
                                .getLatestInAverageProcessingTimeForProxy(server.getServerId(),
                                sequence.getSequence()));
                        if (maxBarWidhA < tmpInt) {
                            maxBarWidhA = tmpInt;
                        }
                        tmpInt = new Float(statQueryDSClient
                                .getLatestInMaximumProcessingTimeForProxy(server.getServerId(),
                                sequence.getSequence()));
                        if (maxBarWidhA < tmpInt) {
                            maxBarWidhA = tmpInt;
                        }
                        tmpInt = new Float(statQueryDSClient
                                .getLatestInMinimumProcessingTimeForProxy(server.getServerId(),
                                sequence.getSequence()));
                        if (maxBarWidhA < tmpInt) {
                            maxBarWidhA = tmpInt;
                        }

                        //bar witdh B part
                        tmpInt = new Float(statQueryDSClient.getLatestInCumulativeCountForSequence(
                                server.getServerId(), sequence.getSequence()));
                        if (maxBarWidhB < tmpInt) {
                            maxBarWidhB = tmpInt;
                        }
                        tmpInt = new Float(statQueryDSClient.getLatestInFaultCountForSequence(server
                                .getServerId(), sequence.getSequence()));
                        if (maxBarWidhB < tmpInt) {
                            maxBarWidhB = tmpInt;
                        }
                    }
                }
            }
        }
    } // end if (serverList != null)
    NumberFormat formatterTime = new DecimalFormat("#.00");
    NumberFormat formatterCount = new DecimalFormat("#.##");
%>
    <%--Set the javascript global var to get the max width--%>
<script type="text/javascript">
    var maxBarWidhA = <%=maxBarWidhA%>;
    var maxBarWidhB = <%=maxBarWidhB%>;
</script>
<%
    int i = 0;
      List<MediationDataBean> mediationDataBeanList = new ArrayList<MediationDataBean>();
    if (serverList != null) {
        for (MonitoredServerDTO server : serverList) {

            i++;
            int j = 0; //initiate second level tree which is always 0,1,2
            Endpoint[] endpointsList = statQueryDSClient.getEndpoints(server.getServerId());
            ProxyService[] proxyServicesList = statQueryDSClient.getProxyServices(server
                    .getServerId());
            Sequence[] sequenceList = statQueryDSClient.getSequences(server.getServerId());

            if ((endpointsList != null && endpointsList.length > 0)
                    || (proxyServicesList != null && proxyServicesList.length > 0)
                    || (sequenceList != null && sequenceList.length > 0)) { // has data?
                hasData = true;

%>
<li <%if (serverList.length != i) {%> class="vertical-line" <%}%>>
<div class="minus-icon" onclick="treeColapse(this)"></div>
<div class="mediators level1"><%=server.getServerURL()%>
</div>
<div class="branch-node"></div>
<%
    } // has data
    int k = 0;
    if (endpointsList != null && endpointsList.length > 0) {
%>
<ul class="child-list">
    <li class="vertical-line">
        <div class="minus-icon" onclick="treeColapse(this)"></div>
        <div class="mediators levelSub<%=j%>"><fmt:message
                key="endpoints"/></div>
        <div class="branch-node"></div>
        <script type="text/javascript">
           var hasDataAnyWhere = true;
        </script>
        <%
            j++;
            for (Endpoint endpoint : endpointsList) {
                if (endpoint != null) {
                    k++;

                    String epAvgTime = statQueryDSClient
                            .getLatestInAverageProcessingTimeForEndpoint(server.getServerId(),
                                    endpoint.getEndpoint());
                    epAvgTime = formatterTime.format(Float.parseFloat(epAvgTime));
                    String epMaxTime = statQueryDSClient
                            .getLatestInMaximumProcessingTimeForEndpoint(server.getServerId(),
                                    endpoint.getEndpoint());
                    epMaxTime = formatterTime.format(Float.parseFloat(epMaxTime));
                    String epMinTime = statQueryDSClient
                            .getLatestInMinimumProcessingTimeForEndpoint(server.getServerId(),
                                    endpoint.getEndpoint());
                    epMinTime = formatterTime.format(Float.parseFloat(epMinTime));
                    String epReqCount = statQueryDSClient.getLatestInCumulativeCountForEndpoint(
                            server.getServerId(), endpoint.getEndpoint());
                    epReqCount = formatterCount.format(Float.parseFloat(epReqCount));
                    String epFaultCount = statQueryDSClient.getLatestInFaultCountForEndpoint(
                            server.getServerId(), endpoint.getEndpoint());
                    epFaultCount = formatterCount.format(Float.parseFloat(epFaultCount));

                    MediationDataBean mediationDataBean = new MediationDataBean();
                    mediationDataBean.setServerURL(server.getServerURL());
                    mediationDataBean.setServiceName(endpoint.getEndpoint());
                    mediationDataBean.setOperation("Endpoints");
                    mediationDataBean.setAvgTime(epAvgTime);
                    mediationDataBean.setMaxTime(epMaxTime);
                    mediationDataBean.setMinTime(epMinTime);
                    mediationDataBean.setReqCount(epReqCount);
                    mediationDataBean.setFaultCount(epFaultCount);

                    mediationDataBeanList.add(mediationDataBean);

        %>

        <ul class="child-list">
            <li <%if (endpointsList.length != k) {%> class="vertical-line"
                    <%}%>>
                <div class="alone-icon" onclick="treeColapse(this)"></div>
                <div class="mediators levelSubChild<%=j%>"><a
                        onclick="showHideData(this,'<%=endpoint.getEndpoint()%>','<%=i%><%=j%><%=k%>','L3')"><%=endpoint.getEndpoint()%><img
                        src="images/up.png" alt="Hide Data" align="top" hspace="5"/></a>


                    <div class="data-chart" id="L3graph_A<%=i%><%=j%><%=k%>"></div>

                    <script type="text/javascript">

                        generateGraph([
                            ["<fmt:message key="endpoint.average.time"/>",'<%=epAvgTime%>'],
                            ["<fmt:message key="endpoint.maximum.time"/>",'<%=epMaxTime%>'],
                            ["<fmt:message key="endpoint.minimum.time"/>",'<%=epMinTime%>']
                        ], "L3graph_A<%=i%><%=j%><%=k%>", 'A');

                    </script>


                    <div class="data-chart" id="L3graph_B<%=i%><%=j%><%=k%>"></div>

                    <script type="text/javascript">

                        generateGraph([
                            ["<fmt:message key="endpoint.request.count"/>",'<%=epReqCount%>'],
                            ["<fmt:message key="endpoint.fault.count"/>",'<%=epFaultCount%>']
                        ], "L3graph_B<%=i%><%=j%><%=k%>", 'B');

                    </script>
                    <span class="BarClear"></span></div>
                <div class="empty-brake"/>
            </li>
        </ul>
        <%
                }
            }
        %>
    </li>
</ul>
<%
    }
%> <%
    k = 0;
    if (proxyServicesList != null && proxyServicesList.length > 0) {
%>
<div class="branch-node"></div>
<ul class="child-list">
    <li class="vertical-line">
        <div class="minus-icon" onclick="treeColapse(this)"></div>
        <div class="mediators levelSub<%=j%>">Proxy Services</div>
        <script type="text/javascript">
          var hasDataAnyWhere = true;
        </script>
        <div class="branch-node"></div>
        <%
            j++;
            for (ProxyService proxyService : proxyServicesList) {
                if (proxyService != null) {
                    k++;

                    String proxyAvgTime = statQueryDSClient
                            .getLatestInAverageProcessingTimeForProxy(server.getServerId(),
                                    proxyService.getProxyService());
                    proxyAvgTime = formatterTime.format(Float.parseFloat(proxyAvgTime));
                    String proxyMaxTime = statQueryDSClient
                            .getLatestInMaximumProcessingTimeForProxy(server.getServerId(),
                                    proxyService.getProxyService());
                    proxyMaxTime = formatterTime.format(Float.parseFloat(proxyMaxTime));
                    String proxyMinTime = statQueryDSClient
                            .getLatestInMinimumProcessingTimeForProxy(server.getServerId(),
                                    proxyService.getProxyService());
                    proxyMinTime = formatterTime.format(Float.parseFloat(proxyMinTime));
                    String proxyReqCount = statQueryDSClient.getLatestInCumulativeCountForProxy(
                            server.getServerId(), proxyService.getProxyService());
                    proxyReqCount = formatterCount.format(Float.parseFloat(proxyReqCount));
                    String proxyFaultCount = statQueryDSClient.getLatestInFaultCountForProxy(
                            server.getServerId(), proxyService.getProxyService());
                    proxyFaultCount = formatterCount.format(Float.parseFloat(proxyFaultCount));

                    MediationDataBean mediationDataBean = new MediationDataBean();
                    mediationDataBean.setServerURL(server.getServerURL());
                    mediationDataBean.setServiceName(proxyService.getProxyService());
                    mediationDataBean.setOperation("Proxy Services");
                    mediationDataBean.setAvgTime(proxyAvgTime);
                    mediationDataBean.setMaxTime(proxyMaxTime);
                    mediationDataBean.setMinTime(proxyMinTime);
                    mediationDataBean.setReqCount(proxyReqCount);
                    mediationDataBean.setFaultCount(proxyFaultCount);

                    mediationDataBeanList.add(mediationDataBean);


        %>
        <ul class="child-list">
            <li <%if (proxyServicesList.length != k) {%> class="vertical-line"
                    <%}%>>
                <div class="alone-icon" onclick="treeColapse(this)"></div>
                <div class="mediators levelSubChild<%=j%>"><a
                        onclick="showHideData(this,'<%=proxyService.getProxyService()%>','<%=i%><%=j%><%=k%>','L3')"><%=proxyService.getProxyService()%><img
                        src="images/up.png" alt="Hide Data" align="top" hspace="5"/></a>

                    <div class="data-chart" id="L3graph_A<%=i%><%=j%><%=k%>"></div>

                    <script type="text/javascript">

                        generateGraph([
                            ['Proxy Service Average Time','<%=proxyAvgTime%>'],
                            ['Proxy Service Maximum Time','<%=proxyMaxTime%>'],
                            ['Proxy Service Minimum Time','<%=proxyMinTime%>']
                        ], "L3graph_A<%=i%><%=j%><%=k%>", 'A');

                    </script>

                    <div class="data-chart" id="L3graph_B<%=i%><%=j%><%=k%>"></div>

                    <script type="text/javascript">

                        generateGraph([
                            ['Proxy Service Request Time','<%=proxyReqCount%>'],
                            ['Proxy Service Fault Count','<%=proxyFaultCount%>']
                        ], "L3graph_B<%=i%><%=j%><%=k%>", 'B');

                    </script>
                    <span class="BarClear"></span></div>
                <div class="empty-brake"/>
            </li>
        </ul>
        <%
                }
            }
        %>
    </li>
</ul>
<%
    }
%> <%
    k = 0;
    if (sequenceList != null && sequenceList.length > 0) {
%>
<div class="branch-node"></div>
<ul class="child-list">
    <li>
        <div class="minus-icon" onclick="treeColapse(this)"></div>
        <div class="mediators levelSub<%=j%>">Sequences</div>
        <div class="branch-node"></div>
        <script type="text/javascript">
           var hasDataAnyWhere = true;
        </script>
        <%
            j++;
            for (Sequence sequence : sequenceList) {
                if (sequence != null) {
                    k++;
                    String seqAvgTime = statQueryDSClient
                            .getLatestInAverageProcessingTimeForSequence(server.getServerId(),
                                    sequence.getSequence());
                    seqAvgTime = formatterTime.format(Float.parseFloat(seqAvgTime));
                    String seqMaxTime = statQueryDSClient
                            .getLatestInMaximumProcessingTimeForSequence(server.getServerId(),
                                    sequence.getSequence());
                    seqMaxTime = formatterTime.format(Float.parseFloat(seqMaxTime));
                    String seqMinTime = statQueryDSClient
                            .getLatestInMinimumProcessingTimeForSequence(server.getServerId(),
                                    sequence.getSequence());
                    seqMinTime = formatterTime.format(Float.parseFloat(seqMinTime));
                    String seqReqCount = statQueryDSClient.getLatestInCumulativeCountForSequence(
                            server.getServerId(), sequence.getSequence());
                    seqReqCount = formatterCount.format(Float.parseFloat(seqReqCount));
                    String seqFaultCount = statQueryDSClient.getLatestInFaultCountForSequence(
                            server.getServerId(), sequence.getSequence());
                    seqFaultCount = formatterCount.format(Float.parseFloat(seqFaultCount));

                    MediationDataBean mediationDataBean = new MediationDataBean();
                    mediationDataBean.setServerURL(server.getServerURL());                    
                    mediationDataBean.setServiceName(sequence.getSequence());
                    mediationDataBean.setOperation("Sequences");
                    mediationDataBean.setAvgTime(seqAvgTime);
                    mediationDataBean.setMaxTime(seqMaxTime);
                    mediationDataBean.setMinTime(seqMinTime);
                    mediationDataBean.setReqCount(seqReqCount);
                    mediationDataBean.setFaultCount(seqFaultCount);

                    mediationDataBeanList.add(mediationDataBean);


        %>
        <ul class="child-list">
            <li <%if (sequenceList.length != k) {%> class="vertical-line" <%}%>>
                <div class="alone-icon" onclick="treeColapse(this)"></div>
                <div class="mediators levelSubChild<%=j%>"><a
                        onclick="showHideData(this,'<%=sequence.getSequence()%>','<%=i%><%=j%><%=k%>','L3')"><%=sequence.getSequence()%><img
                        src="images/up.png" alt="Hide Data" align="top" hspace="5"/></a>


                    <div class="data-chart" id="L3graph_A<%=i%><%=j%><%=k%>"></div>

                    <script type="text/javascript">

                        generateGraph([
                            ["<fmt:message key="sequence.average.time"/>",
                                '<%=seqAvgTime%>'],
                            ["<fmt:message key="sequence.maximum.time"/>",'<%=seqMaxTime%>'],
                            ["<fmt:message key="sequence.minimum.time"/>",'<%=seqMinTime%>']
                        ], "L3graph_A<%=i%><%=j%><%=k%>", 'A');

                    </script>

                    <div class="data-chart" id="L3graph_B<%=i%><%=j%><%=k%>"></div>

                    <script type="text/javascript">

                        generateGraph([
                            ["<fmt:message key="sequence.request.time"/>",
                                '<%=seqReqCount%>'],
                            ["<fmt:message key="sequence.fault.count"/>",'<%=seqFaultCount%>']
                        ], "L3graph_B<%=i%><%=j%><%=k%>", 'B');

                    </script>
                    <span class="BarClear"></span></div>
                <div class="empty-brake"/>
            </li>
        </ul>
        <%
            }
            }
        %>

    </li>
</ul>
<%
        
    }
%>

</li>
<%

        }


    }
    List<MediationDataBean> rpData;
    MediationDataReportDataManager reportDataManager = new MediationDataReportDataManager();
    try {
        rpData = reportDataManager.getReportData(mediationDataBeanList);
    } catch (ReportingException e) {
      throw new ReportingException("mediation report data generation fail");
    }
    request.getSession().setAttribute("reportMediationData",rpData);

    if (!hasData) {
%>

<script type="text/javascript">
    if(hasDataAnyWhere){
         document.getElementById("report_ui").style.display = "";
         document.getElementById("noDataError").style.display = "none";
    }   else{
        document.getElementById("report_ui").style.display = "none";
        document.getElementById("noDataError").style.display = "";
    }

</script>
<%
    }

%>
</ul>

</fmt:bundle>
