<!--
~ Copyright 2009 WSO2, Inc. (http://wso2.com)
~
~ Licensed under the Apache License, Version 2.0 (the "License");
~ you may not use this file except in compliance with the License.
~ You may obtain a copy of the License at
~
~ http://www.apache.org/licenses/LICENSE-2.0
~
~ Unless required by applicable law or agreed to in writing, software
~ distributed under the License is distributed on an "AS IS" BASIS,
~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
~ See the License for the specific language governing permissions and
~ limitations under the License.
-->

<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar"
	prefix="carbon"%>
<%@ page import="org.apache.axis2.context.ConfigurationContext"%>
<%@ page import="org.wso2.carbon.CarbonConstants"%>
<%@ page
	import="org.wso2.carbon.bam.mgt.ui.BAMUIConstants"%>
<%@ page import="static org.wso2.carbon.bam.mgt.ui.BAMUIConstants.*"%>
<%@ page
	import="static org.wso2.carbon.bam.mgt.ui.BAMUIConstants.ACTION_SUBMIT"%>
<%@ page
	import="org.wso2.carbon.bam.mgt.ui.client.BAMConfigAdminServiceClient"%>
<%@ page import="org.wso2.carbon.bam.mgt.ui.stub.bamconfig.types.carbon.MonitoredServerDTO"%>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage"%>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil"%>
<%@page import="org.wso2.carbon.utils.ServerConstants"%>
<!--link media="all" type="text/css" rel="stylesheet" href="css/registration.css"/-->

<script type="text/javascript" src="../carbon/admin/js/breadcrumbs.js"></script>
<script type="text/javascript" src="../carbon/admin/js/cookies.js"></script>
<script type="text/javascript" src="../carbon/admin/js/main.js"></script>

<fmt:bundle basename="org.wso2.carbon.bam.mgt.ui.i18n.Resources">
<carbon:breadcrumb label="add.server"
                   resourceBundle="org.wso2.carbon.bam.mgt.ui.i18n.Resources"
                   topPage="false" request="<%=request%>" />


<%
    final String topic = "/carbon/bam/data/publishers/service_stats";

    if (request.getParameter(ACTION_SUBMIT) != null) {
        String serverURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);

        ConfigurationContext configContext =
                (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
        String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
        MonitoredServerDTO dto = new MonitoredServerDTO();
        String monitoredServerURL = request.getParameter(SERVER_URL);
        if (monitoredServerURL != null) {
            monitoredServerURL = monitoredServerURL.trim();
            if (monitoredServerURL.length() > 1 && monitoredServerURL.charAt(monitoredServerURL.length() - 1) == '/') { // remove trailing '/'
                monitoredServerURL = monitoredServerURL.substring(0, monitoredServerURL.length() -1);
            }
        }
        dto.setServerURL(monitoredServerURL);
        dto.setUsername(request.getParameter(USERNAME));
        dto.setPassword(request.getParameter(PASSWORD));
        String serverType = request.getParameter("ServerType");
        dto.setServerType(serverType);

        dto.setDescription(request.getParameter("descriptionText"));

        String statisticsType = request.getParameter("StatisticsType");
        int statType = 0;
        String subscriberServiceURL = null;
	    String passWord=request.getParameter(PASSWORD);
        String userName=request.getParameter(USERNAME);
        String brokerURL = monitoredServerURL + BAMUIConstants.EVENT_BROKER_SERVICE;
        if ("Service".equals(statisticsType)) {
            statType = 1;
            subscriberServiceURL = serverURL + BAMUIConstants.BAM_SERVICE_STATISTICS_SUBSCRIBER_SERVICE;

        }
        else if("Message".equals(statisticsType)){
            statType = 2;
            subscriberServiceURL = serverURL + BAMUIConstants.BAM_SERVICE_ACTIVITY_STATISTICS_SUBSCRIBER_SERVICE;

        }
        else if("Mediation".equals(statisticsType)){
            statType = 4;
            subscriberServiceURL = serverURL + BAMUIConstants.BAM_USER_DEFINED_DATA_SUBSCRIBER_SERVICE;
        }
 
 		else {
            statType = 8;
        }

        if (serverType.equals(BAMUIConstants.SERVER_TYPE_GENERIC)) {
            statType = 8;
        }

        dto.setCategory(statType);
 	 if (serverType.equals(BAMUIConstants.SERVER_TYPE_JMX)) {

        }

        if (serverType.equals(BAMUIConstants.SERVER_TYPE_PULL)) {
            dto.setPollingInterval(Long.parseLong(request.getParameter(POLLING_INTERVAL)));
        }

        try {
            if (serverType.equals(BAMUIConstants.SERVER_TYPE_EVENTING)) {
                BAMConfigAdminServiceClient client;
                client = new BAMConfigAdminServiceClient(cookie, serverURL, configContext);
                String subID = client.subscribe(topic, brokerURL, subscriberServiceURL, userName, passWord);
                dto.setSubscriptionID(subID);
            }
            try{
                BAMConfigAdminServiceClient client;
                client = new BAMConfigAdminServiceClient(cookie, serverURL, configContext);
                client.addServer(dto);
            }
            catch(Exception e){
                response.setStatus(500);
                CarbonUIMessage uiMsg = new CarbonUIMessage(CarbonUIMessage.ERROR, e.getMessage(), e);
                session.setAttribute(CarbonUIMessage.ID, uiMsg);
%>
<jsp:include page="../admin/error.jsp?<%=e.getMessage()%>" />
<%
        return;
    }
%>

<script type="text/javascript">
    jQuery(document).init(function() {
        function handleOK() {
            window.location = 'list_servers.jsp?region=region1&item=monitored_server_list_menu';
        }

        CARBON.showInfoDialog("<fmt:message key="server.successfully.added"/>", handleOK);
    });
</script>
<%
    //CarbonUIMessage.sendCarbonUIMessage("Server successfully added", CarbonUIMessage.INFO, request);
} catch (Exception e) {
    String errorString = "Error adding server.";
    if (serverType.equals(BAMUIConstants.SERVER_TYPE_EVENTING)) {
        errorString += " Failed to subscribe to " + brokerURL;
    }
%>
<script type="text/javascript">
    jQuery(document).init(function() {
        CARBON.showErrorDialog('<%=errorString%>');
    });
</script>
<%
        }
    }
%>


<script type="text/javascript">

    function validate() {
        value = document.getElementsByName("<%=SERVER_URL%>")[0].value;
        if (value == '') {
            CARBON.showWarningDialog("<fmt:message key="server.url.is.required"/>");
            return false;
        }
        value = document.getElementsByName("<%=USERNAME%>")[0].value;
        if (value == '' && document.getElementById('pullServerInput').checked) {
            CARBON.showWarningDialog("<fmt:message key="username.is.required"/>");
            return false;
        }
        value = document.getElementsByName("<%=PASSWORD%>")[0].value;
        if (value == '' && document.getElementById('pullServerInput').checked) {
            CARBON.showWarningDialog("<fmt:message key="password.is.required"/>");
            return false;
        }
        value = document.getElementsByName("<%=POLLING_INTERVAL%>")[0].value;
        if ((value == '' || !(/^[0-9]+$/.test(value))) && document.getElementById('pullServerInput').checked) {
            CARBON.showWarningDialog("<fmt:message key="invalid.polling.interval"/>");
            return false;
        }

        document.addJMXServerForm.submit();

        return true;
    }

    function displayPullServerOptions() {
        document.getElementById('statTypeTR').style.display='';
        document.getElementById('statTypeSpan').style.display='none';
        document.getElementById('usernameTR').style.display='';
        document.getElementById('passwordTR').style.display='';
        document.getElementById('pollingIntervalTR').style.display='none';
    }

    function displayPushServerOptions() {
        document.getElementById('statTypeTR').style.display='';
        document.getElementById('statTypeSpan').style.display='';
        document.getElementById('usernameTR').style.display='';
        document.getElementById('passwordTR').style.display='';
     
    }

    function displayGenericServerOptions() {
        document.getElementById('statTypeTR').style.display='none';
        document.getElementById('usernameTR').style.display='none';
        document.getElementById('passwordTR').style.display='none';
        document.getElementById('pollingIntervalTR').style.display='none';
    }
  function displayJMXServerOptions() {
        document.getElementById('statTypeTR').style.display='none';
        document.getElementById('usernameTR').style.display='';
        document.getElementById('passwordTR').style.display='';
    }


</script>

	<div id="middle">
	<h2><fmt:message key="add.monitored.server" /></h2>

	<div id="workArea">
	<form method="post" name="addJMXServerForm" action="add_server.jsp"
		target="_self">
	<table style="width: 100%" class="styledLeft">
		<thead>
			<tr>
				<th colspan="2"><fmt:message key="add.server.to.monitor" /></th>
			</tr>
		</thead>
		<tbody>
			<tr>
				<td class="formRow">
				<table class="normal" cellspacing="0">
					<tr>
						<td class="leftCol-small"><fmt:message key="server.url" /><span
							class="required">*</span></td>
						<td><input class="text-box-big" id="<%=SERVER_URL%>"
							name="<%=SERVER_URL%>" type="text"></td>
					</tr>
					<tr>
						<td class="leftCol-small"><fmt:message key="server.type" /><span
							class="required">*</span></td>
						<td>
                            <input id="pullServerInput" type="radio"
							name="ServerType" value="PullServer" checked
							onclick="displayPullServerOptions();"> <fmt:message
							key="server.type.polling" />
                            <input type="radio"
							name="ServerType" value="EventingServer"
							onclick="displayPushServerOptions();"> <fmt:message
							key="server.type.eventing" />
                            <input type="radio"
							name="ServerType" value="GenericServer"
							onclick="displayGenericServerOptions();"> <fmt:message
							key="server.type.generic" /> 
							<input id="jmxServerInput" type="radio"
							name="ServerType" value="JMXServer" 
							onclick="displayJMXServerOptions();"> <fmt:message
							key="server.type.jmx" /><br>
						</td>
					</tr>

					<tr id="statTypeTR">
						<td class="leftCol-small"><fmt:message key="statistics.type" /><span
							class="required">*</span></td>
						<td><input type="radio" name="StatisticsType" value="Service"
							checked> <fmt:message key="statistics.type.service" /> <span
							id="statTypeSpan" style="display: none;"> <input
							type="radio" name="StatisticsType" value="Mediation"> <fmt:message
							key="statistics.type.mediation" />
							</span> <br />
						</td>
					</tr>

					<tr id="usernameTR">
						<td class="leftCol-small"><fmt:message key="user.name" /><span
							class="required">*</span></td>
						<td><input class="text-box-big" id="<%=USERNAME%>"
							name="<%=USERNAME%>" type="text"></td>
					</tr>
					<tr id="passwordTR">
						<td class="leftCol-small"><fmt:message key="password" /><span
							class="required">*</span></td>
						<td><input class="text-box-big" id="<%=PASSWORD%>"
							name="<%=PASSWORD%>" type="password"></td>
					</tr>
                    <tr id="pollingIntervalTR" style="display:none">
                        <td class="leftCol-small"><fmt:message key="polling.interval" />
                        <td><input class="text-box-big" id="<%=POLLING_INTERVAL%>"
                            name="<%=POLLING_INTERVAL%>" type="text" value="60"></td>
                    </tr>
					<tr>
						<td class="leftCol-small"><fmt:message
							key="server.description" /></td>
						<td><textarea id="descriptionText" name="descriptionText"
							style="width: 250px"></textarea></td>
					</tr>
					<input type="hidden" id="<%=ACTION_SUBMIT%>"
						name="<%=ACTION_SUBMIT%>" type="text" value="<%=ACTION_SUBMIT%>">
				</table>
				</td>
			</tr>
			<tr>
				<td class="buttonRow" colspan="2"><input name="adduser"
					type="button" class="button" value="<fmt:message key="add"/>"
					onclick="validate();" /> <input type="button" class="button"
					onclick="javascript:location.href='list_servers.jsp?region=region1&item=monitored_server_list_menu'"
					value="<fmt:message key="cancel"/>" /></td>
			</tr>
		</tbody>
	</table>

	</form>
	</div>
	</div>
</fmt:bundle>
