<!--
~ Copyright 2009 WSO2, Inc. (http://wso2.com)
~
~ Licensed under the Apache License, Version 2.0 (the "License");
~ you may not use this file except in compliance with the License.
~ You may obtain a copy of the License at
~
~ http://www.apache.org/licenses/LICENSE-2.0
~
~ Unless required by applicable law or agreed to in writing, software
~ distributed under the License is distributed on an "AS IS" BASIS,
~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
~ See the License for the specific language governing permissions and
~ limitations under the License.
-->

<%@ page import="org.apache.axis2.context.ConfigurationContext"%>
<%@ page import="org.wso2.carbon.CarbonConstants"%>
<%@ page import="org.wso2.carbon.bam.mgt.ui.BAMUIConstants"%>
<%@ page
	import="org.wso2.carbon.bam.mgt.ui.client.BAMConfigAdminServiceClient"%>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil"%>
<%@ page import="org.wso2.carbon.utils.ServerConstants"%>
<%@ page
	import="org.wso2.carbon.bam.mgt.ui.stub.bamconfig.types.carbon.MonitoredServerDTO"%>
<%@ page import="org.wso2.carbon.bam.core.BAMConstants"%>

<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar"
	prefix="carbon"%>
<%@page import="org.wso2.carbon.ui.CarbonUIMessage"%>

<script type="text/javascript" src="../carbon/admin/js/breadcrumbs.js"></script>
<script type="text/javascript" src="../carbon/admin/js/cookies.js"></script>
<script type="text/javascript" src="../carbon/admin/js/main.js"></script>

<fmt:bundle basename="org.wso2.carbon.bam.mgt.ui.i18n.Resources">
	<carbon:breadcrumb label="server.list"
		resourceBundle="org.wso2.carbon.bam.mgt.ui.i18n.Resources"
		topPage="false" request="<%=request%>" />

	<%
		String serverID = request.getParameter(BAMUIConstants.PARAM_SERVER_ID);
			BAMConfigAdminServiceClient client=null;
			if (serverID != null) {
				String serverURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
				ConfigurationContext configContext = (ConfigurationContext) config.getServletContext()
						.getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
				String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
				try {
					client = new BAMConfigAdminServiceClient(cookie, serverURL, configContext);
				} catch (Exception e) {
					response.setStatus(500);
					CarbonUIMessage uiMsg = new CarbonUIMessage(CarbonUIMessage.ERROR, e.getMessage(), e);
					session.setAttribute(CarbonUIMessage.ID, uiMsg);
	%>
	<jsp:include page="../admin/error.jsp?<%=e.getMessage()%>" />
	<%
		return;
				}
			} else {
				//TODO
			}
	%>
	<%
		//TODO very inefficient
			MonitoredServerDTO[] servers = client.getServerList();
	%>

	<div id="middle">
	<h2><fmt:message key="server.details" /></h2>

	<div id="workArea">
	<%
		if (serverID != null) {
				for (MonitoredServerDTO server : servers) {
					if (server.getServerId() == Integer.parseInt(serverID)) {
	%>
	<table style="width: 100%" class="styledLeft">
		<thead>
			<tr>
				<th colspan="2"><fmt:message key="server.details" /></th>
			</tr>
		</thead>
		<tbody>
			<tr>
				<td><fmt:message key="server.url" /></td>
				<td><%=server.getServerURL()%></td>
			</tr>
			<tr>
				<td><fmt:message key="server.type" /></td>
				<td>
				<%
					if (BAMConstants.SERVER_TYPE_EVENTING.equals(server.getServerType())) {
				%> <fmt:message key="server.type.eventing" /> <%
 	} else {
 %> <fmt:message key="server.type.polling" /> <%
 	}
 %>
				</td>
			</tr>
			<tr>
				<td><fmt:message key="user.name" /></td>
				<td><%=server.getUsername()%></td>
			</tr>
			<tr>
				<td><fmt:message key="password" /></td>
				<td>********</td>
			</tr>
			<tr>
				<td class="buttonRow" colspan="2"><input type="button"
					class="button"
					onclick="javascript:location.href='list_servers.jsp?region=region3&item=monitored_server_list_menu&ordinal=0'"
					value="Back" /></td>
			</tr>
		</tbody>
	</table>
	<%
		}
				}
			}
	%>
	</div>
	</div>
</fmt:bundle>
